#ifndef DBOX_WWW_H

#define DBOX_WWW_H

#include <string>
#include <vector.h>
#include <map>

#include <mtoolrfc.h>
#include <mimeparse.h>
#include "isockett.h"
#include "htmlformat.h"

class do_basic_wwwt
 {
 public:
  virtual void do_www(const string &_url);
  do_basic_wwwt();
  virtual ~do_basic_wwwt();

 protected:
  string url, protocol, host, port, path;
  bool end;
  htmlformatt *htmlformat;
  unsigned redirection;
  string source;
  
  class cache_entryt
   {
   public:
    htmlformatt htmlformat;
   };
   
  map<string,cache_entryt> cache;

  class historyt
   {
   public:
    unsigned page;
    string url, title;
    bool page_has_link;
    unsigned current_link;
    
    void clear();
    
    historyt() { clear(); }
   } current;

  vector<historyt> history_stack;

  virtual bool get_and_format();
  virtual bool get_and_format2();
  virtual bool format_html(const string &page);
  virtual bool get_and_format_internal();
  virtual bool get_and_format_error();
  virtual bool get_and_format_source();
  virtual bool content_type_not_builtin(mimeheadert content_type,
                                        const rfcmessaget &msg);
  virtual bool go_back();
  virtual void mailto();

  // HTTP

  virtual bool get_and_format_http();
  virtual bool format_http(const string &http);
  virtual bool format_http_msg(const string &status_response,
                               const rfcmessaget &msg);

  // News/NNTP
  
  string news_active_cache_host;
  vector<string> news_active;

  virtual bool get_and_format_nntp();
  virtual bool nntp_error(ibsockett &socket);
  virtual bool open_nntp(ibsockett &socket);
  virtual bool nntp_get_active();
  
  // FTP

  virtual bool get_and_format_ftp();
  virtual void format_ftp_dir(const char *buffer, string &html);
  virtual string get_content_type(const string &filename);
 };

#define MAX_SIZE 10000000

#endif
