/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <ctype.h>

#include <libdbox.h>
#include <nls.h>
#include <charsettools.h>
#include <stringtools.h>

#include "htmlformat.h"

void htmlformatt::form(const vector <tag_paramt> &params)
 {
  formt form;
  form.action=search(params, "action");
  form.method=search(params, "method");

  forms.push_back(form);
 }

void htmlformatt::form_input(const vector <tag_paramt> &params)
 {
  if(forms.size()==0) return;

  form_inputt form_input;
 
   {
    string type=search(params, "type");
    if(type=="hidden")
      form_input.type=form_inputt::HIDDEN;
    else if(type=="submit")
      form_input.type=form_inputt::SUBMIT;
    else
      form_input.type=form_inputt::DEFAULT;
   }

  form_input.value=search(params, "value");
  form_input.name=search(params, "name");

  form_input.size=atol(search(params, "size").c_str());
  if(form_input.size==0)
    form_input.size=40;
  else if(form_input.size>100)
    form_input.size=100;

  form_input.sizey=1;
  form_input.sizex=form_input.size;
  form_input.posx=form_input.posy=0;
  form_input.scrollx=form_input.scrolly=0;
  form_input.form=forms.size()-1;
  form_inputs.push_back(form_input);

  if(form_input.type==form_inputt::HIDDEN)
   {
   }
  else
   {
    linkt link;
    bool old_attr_link=attr_link;
    bool old_attr_preformat=attr_preformat;
    attr_preformat=attr_link=TRUE;

    link.is_form=TRUE;
    link.form_input=form_inputs.size()-1;
    links.push_back(link);

    if(form_input.type==form_inputt::SUBMIT)
     {
      if(form_input.value=="")
        entity_text(nls["online.submit"]);
      else
        entity_text(form_input.value);
     }
    else if(form_input.type==form_inputt::DEFAULT)
     {
      for(unsigned i=0; i<form_input.sizex; i++)
        if(i<form_input.value.size()) 
          text(form_input.value[i]);
        else
          text('_');
     }

    flush_word();

    attr_link=old_attr_link;
    attr_preformat=old_attr_preformat;
   }
 }
