#ifndef DBOX_HTMLVIEW_H

#define DBOX_HTMLVIEW_H

#include "htmlformat.h"

class htmlviewt
 {
 public:
  virtual bool view(htmlformatt &html, string &_url);
  unsigned page, current_link;
  bool page_has_link;
  htmlviewt();
  virtual ~htmlviewt();
  
 protected:
  virtual bool enter_url(string &new_url);
  virtual void reset_attr();
  virtual void set_attr(const htmlchart &htmlchar);
  virtual void draw_statusline(const string &text);
  virtual void draw_title();
  virtual void draw_page();
  virtual void redraw_page();
  virtual void draw_line(unsigned line);
  virtual void mark_link(unsigned link);
  virtual bool next_link(unsigned &link, bool first);
  virtual bool prev_link(unsigned &link, bool last);
  virtual bool get_cursor_pos(unsigned &line, unsigned &offs, bool this_page);
  virtual void set_cursor();
  virtual void page_down();
  virtual void page_up();
  virtual void page_home();
  virtual void page_end();
  virtual void link_up();
  virtual void link_down();
  virtual void follow_link(const string &link, string &new_url);
  virtual bool form_key(word key);
  
  // search
  virtual void search();
  virtual void search_next(bool force_redraw, bool reset_search);
  string search_text;
  unsigned search_line;
  bool search_marked;
  
  htmlchart last_set_attr;
  bool attributes_set;
  
  htmlformatt *html;
  unsigned lines_per_page, pages;
  string title, url;
  bool internal;
 };
 
#endif
