#include <iostream.h>

#include <dboxversion.h>
#include <libdboxversion.h>
#include <cmdline.h>
#include <config.h>
#include <nls.h>
#include "online.h"
#include "www.h"

const char *nls_data[]=
 {
  "online.pageinternal", "Page %u of %u",
  "online.page", "Page %u of %u of %s",
  "online.enterurl", "Enter URL",
  "online.newurl", "^New URL",
  "online.ok", "O^k",
  "online.abort", "^Abort",
  "online.savetext", "Save text?",
  "online.yes", "^Yes",
  "online.no", "^No",
  "online.submit", "&gt;&gt; Submit",
  "online.search", "Search",
  "online.searchnotfound", "Text not found!",
  "online.error", "Error",
  "online.httperror.text", "An error occured while transfering the page.",
  "online.httperror.protocol.title", "Protocol not implemented",
  "online.httperror.protocol.text", "Protocol not implemented",
  "online.httperror.open.title", "Page Transmission Error",
  "online.httperror.open.text", "Socket error",
  "online.httperror.content-type.title", "Error while displaying page",
  "online.httperror.content-type.text", "No way to display page",
  "online.nntperror.title", "NNTP Error",
  "online.nntperror.text", "NNTP protocol error",
  "online.ftperror.title", "FTP Error",
  "online.ftperror.text", "FTP protocol error",
  "online.saveas.title", "Save As",
  "online.saveas.filename", "File name:",
  "online.saveas.saved", "File saved.",
  "online.saveas.failed", "SAVING FAILED!",
  "online.gethostbyname.no_address", "the host exists but has no IP address",
  "online.gethostbyname.host_not_found", "Host not found",
  "online.gethostbyname.no_recovery", "DNS server error",
  "online.gethostbyname.try_again", "DNS server error",
  "online.pressESCforabort1", "Press ESC",
  "online.pressESCforabort2", "to abort", 
  NULL, NULL
 };

void usage()
 {
  cerr << 
    "USAGE: debris [options] [file/URL]\n"  
    "\n"
    "Options:\n"
    "  --help, -?     show usage notes\n"
    "  --version      show version information\n"
    "\n";
 }

void interactive(cmdlinet &cmdline)
 {
  asyncio.initialize();

  online.col1v=16;
  online.col1h=16;
  online.col2v=7;
  online.col2h=4;
  online.col3v=7+8;
  online.col3h=1;

  online.assign("");
  online.open();

  if(cmdline.argcount==0)
    do_www("");
  else
    do_www(cmdline.args[0]);

  online.setattr(0xff, FALSE);
  online.clrscr();
  online.setcursor(1, 1);
  online.close();
 }

int main(int argc, char **argv)
 {
  cmdlinet cmdline;

  nls.set_data(nls_data);

  if(cmdline.parse(argc, argv, "?h(help)(version)"))
   {
    usage();
    return 1;
   }

  if(cmdline.isset('?') || cmdline.isset("help") ||
     cmdline.isset('h'))
   {
    usage();
    return 0;
   }
 
  if(cmdline.isset("version"))
   {
    cout <<
      "This is DEBRIS version "
      DBOXVERSIONNR "/" LIBDBOXVERSIONNR "\n"
      "Copyright(C) 2000 Daniel Kroening\n"
      "\n"
      "DEBRIS comes with ABSOLUTELY NO WARRANTY.\n"
      "This is free software, and you are welcome to redistribute it\n"
      "under certain conditions; press F1 for details.\n";

    return 0;
   }

  config.defaulturl="http://www.dbox.handshake.de/debris/home/";

  interactive(cmdline);
 }
