#ifndef DBOX_SOCKETT_H

#define DBOX_SOCKETT_H

#include <string>

class sockett
 {
 public:
  virtual int form(const char *format, ...);
  virtual char *gets(char *dest, size_t maxlen);
  virtual bool open(const string &address, word port);
  virtual bool close();
  virtual size_t read(void *buf, size_t count);
  virtual size_t write(const void *buf, size_t count);
 
  sockett()
   {
    verbose=FALSE;
    socket_open=FALSE;
    fd=-1;
    socket_error=0;
    connecting=FALSE;
    socket_error_type=SOCKET_ERROR;
   }
   
  virtual ~sockett()
   {
    close();
   }
   
  enum socket_error_typet 
   {
    SOCKET_ERROR, LOOKUP_ERROR
   };
   
  virtual void set_verbose(bool _verbose) { verbose=_verbose; }
  virtual int get_error_number() { return socket_error; }
  virtual int get_error_type() { return socket_error_type; }
  virtual bool is_open() { return socket_open || !input_buffer.empty(); }
   
 protected:
  int socket_error;
  socket_error_typet socket_error_type;
  bool socket_open, verbose, connecting, abort;
  string input_buffer;
  int fd;
   
  virtual void get_socket_state();
 };

#endif
