#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <strstream.h>
#include <fstream.h>

#include <tools.h>
#include <nls.h>
#include <ui.h>
#include "help.h"
#include "online.h"
#include "url.h"
#include "www.h"
#include "basic_www.h"

class do_wwwt:public do_basic_wwwt
 {
 public:
  do_wwwt();
  virtual ~do_wwwt();

 protected:
  virtual bool get_and_format_internal();
  virtual bool content_type_not_builtin
    (mimeheadert content_type, const rfcmessaget &msg);
 };

do_wwwt::do_wwwt()
 {
 }

do_wwwt::~do_wwwt()
 {
 }

bool do_wwwt::content_type_not_builtin
  (mimeheadert content_type, const rfcmessaget &msg)
 {
  string filename;

   {
    unsigned pos=url.find_last_of("/");
    if(pos!=string::npos && pos!=(url.size()-1))
      filename.assign(url, pos+1, url.size()-pos-1);
   }

  while(TRUE)
   {
    if(status.dologout) return TRUE;

    online.setattr(2, FALSE);
    online.box(online.sizex/2-30, 8, 
               online.sizex/2+30, 18, 
               BOXFRAMEDBL, nls["online.saveas.title"], TRUE);

    menut menu(&online);
    menu.x=online.sizex/2-30;
    menu.y=8;

    online.setcursor(menu.x+2, menu.y+2);
    online.printf("URL: %.52s", url.c_str());
    online.setcursor(menu.x+7, menu.y+3);
    online.printf("%.52s", mimeheader2str(content_type).c_str());

    online.setcursor(menu.x+2, menu.y+5);
    online.printf(nls["online.saveas.filename"]);

    editstringmet editme;
    editme.id=0;
    editme.x=3;
    editme.y=6;
    editme.sizex=54;
    editme.maxlen=DIRLEN-1;
    editme.text=&filename;
    menu.add(&editme);

    ok_buttonmet okme;
    okme.id=1;
    okme.x=14;
    okme.y=8;
    menu.add(&okme);

    abort_buttonmet abortme;
    abortme.id=3;
    abortme.x=38;
    abortme.y=8;
    menu.add(&abortme);

    for(bool startover=FALSE; !startover;)
     {
      switch(menu.menu())
       {
       case 1:
        if(status.dologout) return TRUE;
        if(filename=="") return TRUE;

        if(filename.size()>2 &&
           filename[0]=='~' &&
           filename[1]=='/')
         {
          const char *home=getenv("HOME");
          if(home!=NULL)
           {
            string new_filename=home;
            new_filename+=(filename.c_str()+1);
            filename=new_filename;
           }
         }

         {
          ofstream out(filename.c_str());
          if(!out)
           {
            error_box(online, nls["online.saveas.failed"]);
            return TRUE;
           }

          if(!out.write(msg.data+msg.headerlen, msg.len))
           {
            error_box(online, nls["online.saveas.failed"]);
            return TRUE;
           }
         }
        
        info_box(online, nls["online.saveas.saved"]);
        return TRUE;

       case MENU_HELP:
        displayhelp("internet/www/saveas");
        if(status.dologout) return TRUE;
        online.clrscr();
        startover=TRUE;
        break;

       default:
        return TRUE;
       }
     }
   }

  return TRUE;
 }

bool do_wwwt::get_and_format_internal()
 {
  if(host=="help")
   {
    string help_url="http://www.dbox.handshake.de/debris/help/english";
    string new_url=help_url+path;
    parse_url(new_url, protocol, host, port, path);
    return get_and_format_http();
   }

  return do_basic_wwwt::get_and_format_internal();
 }

void dointernet_www(const char *url)
 {
  do_www(url==NULL?"":url);
 }

void do_www(const string &url)
 {
  do_wwwt do_www;
  do_www.do_www(url);
 }

