#ifndef DBOX_MIMEPARSE_H

#define DBOX_MIMEPARSE_H

#include <string>
#include <vector.h>

#include <mtoolrfc.h>

struct mimeattributet
 {
  string name, value;
 };

struct mimeheadert
 {
 public:
  string value, subvalue;
  vector<mimeattributet> attributes;
  bool findattribute (string &dest, const string &name) const;
 };
 
string mimeheader2str(const struct mimeheadert &mimeheader);
void parse_mime_header(const string &text, mimeheadert &mimeheader);

struct mimestructt
 {
 public:
  dword headerlen, len, offset;

  mimeheadert content_type,
              content_transfer_encoding,
              content_disposition;
              
  vector<mimestructt> sub;
  
  mimestructt();

  void mimeparse(rfcmessaget &rfcm);
 };
 
#endif
