#include <ctype.h>
#include <stdio.h>

#include <stringtools.h>
#include <charsettools.h>

int stringcasecmp(const string &a, const string &b)
 {
  return strcasecmp(a.c_str(), b.c_str());
 }

void ibm2ascii(string &s)
 {
  string new_s;

  for(unsigned i=0; i<s.size(); i++)
   {
    char ch=s[i];

    if(ch>=0 && ch<126)
     {
      if(ch>=' ') new_s+=ch;
     }
    else
     {
      switch(ch)
       {
       case '': new_s+="ae"; break;
       case '': new_s+="oe"; break;
       case '': new_s+="ue"; break;
       case '': new_s+="ss"; break;

       case '': 
        new_s+='A';
        new_s+=islower(s[i+1])?'e':'E';
        break;

       case '':
        new_s+='O';
        new_s+=islower(s[i+1])?'e':'E';
        break;

       case '':
        new_s+='U';
        new_s+=islower(s[i+1])?'e':'E';
        break;

       default:
        break;
       }
     }
   }

  s=new_s;
 }

void iso2ascii(string &s)
 {
  string new_s;

  for(unsigned i=0; i<s.size(); i++)
   {
    char ch=s[i];

    if(ch>=0 && ch<126)
     {
      if(ch>=' ') new_s+=ch;
     }
    else
     {
      switch(ch)
       {
       case '': new_s+="ae"; break;
       case '': new_s+="oe"; break;
       case '': new_s+="ue"; break;
       case '': new_s+="ss"; break;

       case '':
        new_s+='A';
        new_s+=islower(s[i+1])?'e':'E';
        break;

       case '':
        new_s+='O';
        new_s+=islower(s[i+1])?'e':'E';
        break;

       case '':
        new_s+='U';
        new_s+=islower(s[i+1])?'e':'E';
        break;

       default:
        break;
       }
     }
   }
 }

void ibm2iso(string &s)
 {
  for(unsigned i=0; i<s.size(); i++)
    ibm2iso(&s[i], 1);
 }

void iso2ibm(string &s)
 {
  for(unsigned i=0; i<s.size(); i++)
    iso2ibm(&s[i], 1);
 }

void upstring(string &s)
 {
  for(unsigned i=0; i<s.size(); i++)
   {
    register char ch=s[i];
    if(isascii(ch) && islower(ch))
      s[i]=toupper(ch);
   }
 }

string up_string(const string &_s)
 {
  string s=_s;
  upstring(s);
  return s;
 }

void dnstring(string &s)
 {
  for(unsigned i=0; i<s.size(); i++)
   {
    register char ch=s[i];
    if(isascii(ch) && isupper(ch))
      s[i]=tolower(ch);
   }
 }

string dn_string(const string &_s)
 {
  string s=_s;
  dnstring(s);
  return s;
 }

bool check_joker(const string &mask, const string &filename,
                bool casei=FALSE)
 {
  return checkjoker(mask.c_str(), filename.c_str(), casei);
 }

string i2string(unsigned i)
 {
  char tempstr[TEXTLEN];
  snprintf(tempstr, TEXTLEN, "%u", i);
  return string(tempstr);
 }

string i2string(signed i)
 {
  char tempstr[TEXTLEN];
  snprintf(tempstr, TEXTLEN, "%d", i);
  return string(tempstr);
 }
